package FilterUtil;

use Exporter;
our @ISA=qw(Exporter);
our @EXPORT_OK=qw(run_command read_file write_file bracket_list);

use File::Temp qw(mktemp);

sub read_file($){
  my $fname=shift;
  local (*F);
  my @lines;

  open(F,"<$fname") ||die "$!";
  @lines=<F>;
  close(F);
  return(@lines);
}

sub run_command($@){
  my $command=shift;
  my @input=@_;

  local (*PIPE,*TMP);
  my $fn=mktemp("/tmp/FilterUtilXXXXXX");

  open(PIPE,"|$command>$fn");
  print PIPE @input;
  close(PIPE) || die  "$command return status $? on input @input";
  open(TMP,"<$fn") || die "$!"; 
  my @lines=<TMP>;
  close(TMP);
  unlink($fn) || die "$!";
  return @lines;
}

sub bracket_list($@){
  my $left=shift;
  my $right=shift;
  my $sep=shift;
  return $left.join("$sep",@_).$right;
}

sub write_file($$@){
  my $where=shift;
  my $force=shift;
  my @lines=@_;
  local(*F);

  if (!$force && -f $where){
  print STDERR "ERROR file $where exists; use force option to overwrite\n";
  return 1;
} else {
  open(F,">$where") || die "$!";
  print F @lines;
  close(F);
  return 0;
}

}
1;
