/**
 * @file   nu_signed_index.h
 * @author David Bremner <bremner@unb.ca>
 * @date   Mon Dec 23 11:43:21 2002
 * 
 * @brief  encode/decode index+sign-set
 * 
 * 
 */

#ifndef NU_SIGNED_INDEX_H
#define NU_SIGNED_INDEX_H

#include "oms_types.h"
#include "nu_sign_encoding.h"

typedef uint32_t nu_signed_index_t;

#define NSI_BITWIDTH 32
#define NSI_RESERVED_BITS 1
#define NSI_SHIFT (NSI_BITWIDTH-SIGN_BITWIDTH-NSI_RESERVED_BITS)
#define NSI_MASK_INDEX (0x0fffffff)
#define NSI_MASK_SIGN  (0xf0000000)

#define NSI_SIGN_MASK 7

#define NSI_MARKER (nu_signed_index_t) 0xffff


#define nsi_encode(k,sign) ((sign<<NSI_SHIFT) | k)

#define nsi_sign(k) ( ( (k & NSI_MASK_SIGN) >> NSI_SHIFT ) & NSI_SIGN_MASK)

#define nsi_index(k) (  k & NSI_MASK_INDEX  )

#endif
