#ifndef _PARSER_H
#define _PARSER_H

#include "gparams.h"
#include "facet_list.h"
#include "nu_sign_set.h"

struct parser_struct {
  bool empty;
  bool uniform;
  bool global; /* has more than one instance */
  facet_list_p facets;
  nu_sign_set_p basis_signs;
  int  chirotope_count,elements;
  int  rank;
  /* how many times has the parser been called */
  int count;
};

extern struct parser_struct parser;

extern bool parse_input(params_p);
extern void parser_init(params_p);


/* callbacks for yacc */

void parser_init(params_p params);
void parser_distance(int source_facet, int sink_facet, int diameter);
void parser_rank(int rank);
void parser_elements(int n);


extern int yydebug;

extern int yyparse();
void yyerror(char *s);
int yywrap(void);
void param_init(void);      
#endif
